﻿using System;
using System.Windows.Forms;
using System.IO;
using System.IO.Pipes;

namespace PipeTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            DateTime start = DateTime.Now;
            String msg = textBox1.Text;
            String status;

            using (NamedPipeClientStream pipeClient = new NamedPipeClientStream(".", "Pipe1", PipeDirection.Out))
            {
                try
                {
                    // Connect to the pipe or wait until the pipe is available.
                    //Console.WriteLine("Attempting to connect to pipe...");
                    pipeClient.Connect(2000);

                    //Console.WriteLine("Connected... {0} pipe server instances open", pipeClient.NumberOfServerInstances);

                    // Send message
                    using (StreamWriter sw = new StreamWriter(pipeClient))
                    {
                        sw.AutoFlush = true;
                        sw.WriteLine(msg);
                        status = "Sent " + pipeClient.NumberOfServerInstances;
                        //Console.WriteLine("Message sent: {0}", textBox1.Text);
                    }
                }
                catch (TimeoutException te)
                {
                    status = "Error";
                    msg = "Connect timeout: " + te.Message;
                }
                catch (IOException ioe)
                {
                    status = "Error";
                    msg = "IO Exception: " + ioe.Message;
                }
                catch (Exception ex)
                {
                    status = "Error";
                    msg = "Exception: " + ex.Message;
                }
            }

            TimeSpan ts = new TimeSpan(DateTime.Now.Ticks - start.Ticks);

            dgvOutput.Rows.Insert(0, start.ToString("HH:mm:ss.fff"), status, msg, ts.Milliseconds);
        }
    }
}
